#include <stdio.h>
#include <windows.h>
#include <math.h>

char port[15] = "\\\\.\\COM3"; // ø Ʈ

#define delay_value 80 //   ӵ 0.05

typedef struct SensorData1 {
	int IR[7];
	int CDS;
	int Bat;
	int CNT;
}SensorData;

HANDLE AltinoComDevId;

unsigned char tx_d[22] = { 0, };
unsigned char Sendbuf[22] = { 0, };
unsigned char rx_d[22] = { 0, };
unsigned char rx_d22[22]= { 0, };
unsigned char rx_data[1028] = { 0, };
unsigned char rx_d_sensor1[22] = { 0, };
unsigned char connectstate = 0;
DWORD dwByte;

HANDLE thread;
SensorData sensor;

SensorData SensorFun(int command);
void delay(int ms);

// 忡 ؼ  Լ.  Լ ϸ 嵵 ȴ
DWORD WINAPI thtimer(void* data) {
    while (1) {
        sensor=SensorFun(10);
        delay(delay_value);
    }
    return 0;
}


unsigned char check_sum_tx_calcuration(int u16_cnt)
{
	int u16_tx_check_sum = 0;
	int u16_tx_cnt;
	for (u16_tx_cnt = 3; u16_tx_cnt <= u16_cnt; u16_tx_cnt++) {
		u16_tx_check_sum = u16_tx_check_sum + tx_d[u16_tx_cnt];
	}
	u16_tx_check_sum = u16_tx_check_sum % 256;
	return (byte)(u16_tx_check_sum);
}

void delay(int ms)
{
    Sleep(ms);
}

void Open()
{
	if (connectstate == 0)
	{
		AltinoComDevId = CreateFile(
			port,
			GENERIC_READ | GENERIC_WRITE,
			0,
			NULL,
			OPEN_EXISTING,
			0,
			NULL);

		COMMTIMEOUTS CommTimeOuts;
		GetCommTimeouts(AltinoComDevId, &CommTimeOuts);
		CommTimeOuts.ReadIntervalTimeout = 500;
		CommTimeOuts.ReadTotalTimeoutMultiplier = 500;
		CommTimeOuts.ReadTotalTimeoutConstant = 500;
		CommTimeOuts.WriteTotalTimeoutMultiplier = 500;
		CommTimeOuts.WriteTotalTimeoutConstant = 500;
		SetCommTimeouts(AltinoComDevId, &CommTimeOuts);

		DCB dcb;
		GetCommState(AltinoComDevId, &dcb);
		dcb.BaudRate = CBR_115200;
		dcb.ByteSize = 8;
		dcb.Parity = NOPARITY;
		dcb.StopBits = 0;
		dcb.fBinary = TRUE;
		dcb.fParity = FALSE;
		SetCommState(AltinoComDevId, &dcb);
		Sleep(500);
		connectstate = 1;
		thread = CreateThread(NULL, 0, thtimer, NULL, 0, NULL);
		printf("Start\n");
	}
}

void BT()
{
    Open();
}

void Bt()
{
    Open();
}

void bt()
{
    Open();
}

void OPEN()
{
    Open();
}

void Close()
{
	if (connectstate == 1)
	{
	    CloseHandle(thread);
		Sleep(500);
		CloseHandle(AltinoComDevId);
		connectstate = 0;
	}
}

void close()
{
    Close();
}

void CLOSE()
{
    Close();
}

void SendData(unsigned char *Sendbuf)
{
    int i;
	tx_d[0] = 0x2;
	tx_d[1] = 22;

	tx_d[3] = (byte)(0x01);
	tx_d[4] = (byte)(0x01);
	for(i=5; i<21; i++) {
            tx_d[i] = Sendbuf[i];
	}
	tx_d[21] = 0x3;

	tx_d[2] = check_sum_tx_calcuration(20);

	PurgeComm(AltinoComDevId, PURGE_TXCLEAR);
	WriteFile(AltinoComDevId, tx_d, 22, &dwByte, 0);
}

void IR_Tunning()
{
    int i;
	tx_d[0] = 0x2;
	tx_d[1] = 22;

	tx_d[3] = (byte)(0x01);
	tx_d[4] = (byte)(0x06);
	for(i=5; i<21; i++) {
            tx_d[i] = 0x00;
	}
	tx_d[21] = 0x3;

	tx_d[2] = check_sum_tx_calcuration(20);

	PurgeComm(AltinoComDevId, PURGE_TXCLEAR);
	WriteFile(AltinoComDevId, tx_d, 22, &dwByte, 0);
}

void EEPROM_Flash()
{
    int i;
	tx_d[0] = 0x2;
	tx_d[1] = 22;

	tx_d[3] = (byte)(0x01);
	tx_d[4] = (byte)(0x07);
	for(i=5; i<21; i++) {
            tx_d[i] = 0x00;
	}
	tx_d[21] = 0x3;

	tx_d[2] = check_sum_tx_calcuration(20);

	PurgeComm(AltinoComDevId, PURGE_TXCLEAR);
	WriteFile(AltinoComDevId, tx_d, 22, &dwByte, 0);
}

void IRSet()
{
    printf("IR_Tunning...");
    IR_Tunning(); delay(1000);
    printf("IR_EEPROM_FLASH...");
    EEPROM_Flash();delay(1000);
    printf("IR SET");
}


void Go(int left, int right)
{
    if(right>1000)right=1000;
    if(right<-1000)right=-1000;

    if(right>=0)
    {
        Sendbuf[6] = right/256;
        Sendbuf[7] = right%256;
    }
    else
    {
        right = right * -1;
        right = ~right;
        Sendbuf[6] = (right >> 8) & 0xFF;
        Sendbuf[7] = right & 0xFF;
    }

    if(left>1000)left=1000;
    if(left<-1000)left=-1000;


    if(left>=0)
    {
        Sendbuf[8] = left/256;
        Sendbuf[9] = left%256;
    }
    else
    {
        left = left * -1;
        left = ~left;
        Sendbuf[8] = (left >> 8) & 0xFF;
        Sendbuf[9] = left & 0xFF;
    }
}

void go(int left, int right)
{
    Go(left,right);
}

void GO(int left, int right)
{
    Go(left,right);
}

void Steering(int steeringvalue)
{

    if(steeringvalue>127) steeringvalue=127;
    else if(steeringvalue<-127) steeringvalue=-127;

	Sendbuf[5] = (byte)steeringvalue;
}

void steering(int steeringvalue)
{
    Steering(steeringvalue);
}

void STEERING(int steeringvalue)
{
    Steering(steeringvalue);
}

void Sound(unsigned char buzzer)
{
    if(buzzer<0)buzzer=0;
    if(buzzer>255)buzzer=255;
	Sendbuf[19] = (byte)buzzer;
}

void sound(unsigned char buzzer)
{
    Sound(buzzer);
}

void SOUND(unsigned char buzzer)
{
    Sound(buzzer);
}

void Display(unsigned char ASCII)
{
	Sendbuf[10] = ASCII;
	Sendbuf[11] = 0;
	Sendbuf[12] = 0;
	Sendbuf[13] = 0;
	Sendbuf[14] = 0;
	Sendbuf[15] = 0;
	Sendbuf[16] = 0;
	Sendbuf[17] = 0;
	Sendbuf[18] = 0;
}

void display(unsigned char ASCII)
{
    Display(ASCII);
}

void DISPLAY(unsigned char ASCII)
{
    Display(ASCII);
}

void DisplayLine(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
	Sendbuf[10] = 0xff;
	Sendbuf[11] = dot7;
	Sendbuf[12] = dot6;
	Sendbuf[13] = dot5;
	Sendbuf[14] = dot4;
	Sendbuf[15] = dot3;
	Sendbuf[16] = dot2;
	Sendbuf[17] = dot1;
	Sendbuf[18] = dot0;
}

void displayline(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void displayLine(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void DISPLAYLINE(unsigned char dot0, unsigned char dot1, unsigned char dot2, unsigned char dot3, unsigned char dot4, unsigned char dot5, unsigned char dot6, unsigned char dot7)
{
    DisplayLine(dot0,dot1,dot2,dot3,dot4,dot5,dot6,dot7);
}

void Led(unsigned int led)
{
	Sendbuf[20] = led;
}

void Light(unsigned int led)
{
    Led(led);
}

void led(unsigned int led)
{
    Led(led);
}

void LED(unsigned int led)
{
    Led(led);
}

void light(unsigned int led)
{
    Led(led);
}

void LIGHT(unsigned int led)
{
    Led(led);
}

void Displayon(int x, int y)
{
    unsigned char dotx;
    if(y<1||y>8 || x<1 || x>8)
        printf("1 8̿  Էϼ.");
    else {
        Sendbuf[10] = 0xff;
        dotx=Sendbuf[19-x];

        Sendbuf[19-x] = dotx | (unsigned char)pow((double)2,(double)(y-1));
    }
}

void displayon(int x, int y)
{
    Displayon(x,y);
}

void DisplayOn(int x, int y)
{
    Displayon(x,y);
}

void DisplayON(int x, int y)
{
    Displayon(x,y);
}

void DISPLAYON(int x, int y)
{
    Displayon(x,y);
}

void Displayoff(int x, int y)
{
    unsigned char dotx;
	Sendbuf[10] = 0xff;
	if(x<1||x>8 || y<1 || y>8)
        printf("1 8̿  Էϼ.");
	dotx=Sendbuf[19-x];

    Sendbuf[19-x] = dotx & ((byte)(255-pow((double)2,(double)(y-1))));
}

void displayoff(int x, int y)
{
    Displayoff(x,y);
}

void DisplayOff(int x, int y)
{
    Displayoff(x,y);
}

void DisplayOFF(int x, int y)
{
    Displayoff(x,y);
}

void DISPLAYOFF(int x, int y)
{
    Displayoff(x,y);
}

void Stop()
{
    Go(0,0);Steering(0);
    Sound(0);Led(0);
    Display(0);
}

void stop()
{
    Stop();
}

SensorData SensorFun(int command)
{
    int i,j,k;
	SensorData sensordata1;
	SendData(Sendbuf);

    ReadFile(AltinoComDevId, rx_d, 22, &dwByte, 0);

    for(j=0; j<22; j++)
    {
        for(i=0; i<21; i++)
        {
            rx_d22[i]=rx_d22[i+1];
        }
        rx_d22[21]=rx_d[j];
        int rx_check_sum=0;
        if ((rx_d22[0] == 2) && (rx_d22[21] == 3) && (rx_d22[1] == 22)) {

            for(k=3; k<21; k++)
                rx_check_sum = rx_check_sum + rx_d22[k];

            rx_check_sum = rx_check_sum % 256;

            if (rx_check_sum==rx_d22[2])
            {
                for(k=5; k<21; k++)
                    rx_d_sensor1[k] = rx_d22[k];

                for(k=0; k<22; k++)
                    rx_d22[k]=0;

                break;
            }
        }
    }

    PurgeComm(AltinoComDevId, PURGE_RXCLEAR);

	sensordata1.IR[1] = rx_d_sensor1[5] * 256 + rx_d_sensor1[6];
	sensordata1.IR[2] = rx_d_sensor1[7] * 256 + rx_d_sensor1[8];
	sensordata1.IR[3] = rx_d_sensor1[9] * 256 + rx_d_sensor1[10];
	sensordata1.IR[4] = rx_d_sensor1[11] * 256 + rx_d_sensor1[12];
	sensordata1.IR[5] = rx_d_sensor1[13] * 256 + rx_d_sensor1[14];
	sensordata1.IR[6] = rx_d_sensor1[15] * 256 + rx_d_sensor1[16];

	sensordata1.CDS = rx_d_sensor1[17] * 256 + rx_d_sensor1[18];

	sensordata1.Bat = rx_d_sensor1[19] * 256 + rx_d_sensor1[20];

	sensordata1.CNT = sensordata1.CNT +1;
	return sensordata1;
}


